--- old/usr/src/uts/common/io/dld/dld_drv.c	2012-06-12 19:55:16.547117754 +0200
+++ new/usr/src/uts/common/io/dld/dld_drv.c	2012-06-12 19:55:16.570308918 +0200
@@ -1167,8 +1167,7 @@
 
 	sobjp = &ssp->ss_obj;
 
-	if (sobjp->so_class != DLD_SECOBJ_CLASS_WEP &&
-	    sobjp->so_class != DLD_SECOBJ_CLASS_WPA)
+	if (sobjp->so_class == DLD_SECOBJ_CLASS_TLS)
 		return (EINVAL);
 
 	if (sobjp->so_name[DLD_SECOBJ_NAME_MAX - 1] != '\0' ||
--- old/usr/src/uts/common/io/mac/mac.c	2012-06-12 19:55:18.062680297 +0200
+++ new/usr/src/uts/common/io/mac/mac.c	2012-06-12 19:55:18.090776511 +0200
@@ -311,7 +311,6 @@
 #include <sys/pool_pset.h>
 #include <sys/cpupart.h>
 #include <inet/wifi_ioctl.h>
-#include <net/wpa.h>
 
 #define	IMPL_HASHSZ	67	/* prime */
 
@@ -2959,9 +2958,6 @@
 	case MAC_PROP_WL_WPA:
 		minsize = sizeof (wl_wpa_t);
 		break;
-	case MAC_PROP_WL_SCANRESULTS:
-		minsize = sizeof (wl_wpa_ess_t);
-		break;
 	case MAC_PROP_WL_POWER_MODE:
 		minsize = sizeof (wl_ps_mode_t);
 		break;
--- old/usr/src/uts/common/io/net80211/net80211.c	2012-06-12 19:55:23.530885546 +0200
+++ new/usr/src/uts/common/io/net80211/net80211.c	2012-06-12 19:55:23.555024148 +0200
@@ -191,9 +191,6 @@
 void
 ieee80211_notify(ieee80211com_t *ic, wpa_event_type event)
 {
-	if ((ic->ic_flags & IEEE80211_F_WPA) == 0)
-		return;		/* Not running on WPA mode */
-
 	ic->ic_eventq[ic->ic_evq_tail] = event;
 	ic->ic_evq_tail ++;
 	if (ic->ic_evq_tail >= MAX_EVENT) ic->ic_evq_tail = 0;
--- old/usr/src/uts/common/io/net80211/net80211_ioctl.c	2012-06-12 19:55:24.724730847 +0200
+++ new/usr/src/uts/common/io/net80211/net80211_ioctl.c	2012-06-12 19:55:24.748710244 +0200
@@ -64,7 +64,6 @@
 static void wl_get_capability(struct ieee80211com *, void *);
 static int wl_set_wpa(struct ieee80211com *, const void *);
 static void wl_get_wpa(struct ieee80211com *, void *);
-static void wl_get_scanresults(struct ieee80211com *, void *);
 static void wl_get_esslist(struct ieee80211com *, void *);
 static int wl_set_wepkey(struct ieee80211com *, const void *);
 static int wl_set_optie(struct ieee80211com *, const void *);
@@ -732,14 +731,23 @@
 	bcopy(in->in_essid, conf->wl_ess_conf_essid.wl_essid_essid,
 	    in->in_esslen);
 	bcopy(in->in_bssid, conf->wl_ess_conf_bssid, IEEE80211_ADDR_LEN);
-	conf->wl_ess_conf_wepenabled =
-	    (in->in_capinfo & IEEE80211_CAPINFO_PRIVACY ?
-	    WL_ENC_WEP : WL_NOENCRYPTION);
-	conf->wl_ess_conf_bsstype =
-	    (in->in_capinfo & IEEE80211_CAPINFO_ESS ?
-	    WL_BSS_BSS : WL_BSS_IBSS);
+
+	conf->wl_ess_conf_beacon_period = in->in_intval;
+	conf->wl_ess_conf_beacon_tsf = in->in_tstamp.tsf;
+	conf->wl_ess_conf_beacon_age = in->in_rstamp;
+
 	conf->wl_ess_conf_sl = wifi_getrssi(in);
-	conf->wl_ess_conf_reserved[0] = (in->in_wpa_ie == NULL? 0 : 1);
+
+	conf->wl_ess_conf_caps = in->in_capinfo;
+	/* authmode is set to IEEE80211_AUTH_OPEN = 1 by default */
+
+	if (in->in_wpa_ie == NULL) {
+		conf->wl_ess_conf_wpa_ie_len = 0;
+	} else {
+		conf->wl_ess_conf_wpa_ie_len = in->in_wpa_ie[1] + 2;
+		bcopy(in->in_wpa_ie, conf->wl_ess_conf_wpa_ie,
+		    conf->wl_ess_conf_wpa_ie_len);
+	}
 
 	/* physical (FH, DS, ERP) parameters */
 	if (IEEE80211_IS_CHAN_A(chan) || IEEE80211_IS_CHAN_T(chan)) {
@@ -1129,78 +1137,6 @@
 }
 
 /*
- * To be compatible with drivers/tools of OpenSolaris.org,
- * we use a different ID to filter out those APs of WPA mode.
- */
-static int
-wifi_cfg_scanresults(struct ieee80211com *ic, uint32_t cmd, mblk_t **mp)
-{
-	mblk_t *omp;
-	wldp_t *outp;
-	wl_wpa_ess_t *sr;
-	ieee80211_node_t *in;
-	ieee80211_node_table_t *nt;
-	int len, ap_num = 0;
-	int err = 0;
-
-	if ((omp = wifi_getoutmsg(*mp, cmd, MAX_BUF_LEN - WIFI_BUF_OFFSET)) ==
-	    NULL) {
-		return (ENOMEM);
-	}
-	outp = (wldp_t *)omp->b_rptr;
-	sr = (wl_wpa_ess_t *)outp->wldp_buf;
-	sr->count = 0;
-
-	switch (cmd) {
-	case WLAN_GET_PARAM:
-		ieee80211_dbg(IEEE80211_MSG_WPA, "wifi_cfg_scanresults\n");
-		nt = &ic->ic_scan;
-		IEEE80211_NODE_LOCK(nt);
-		in = list_head(&nt->nt_node);
-		while (in != NULL) {
-			/* filter out non-WPA APs */
-			if (in->in_wpa_ie == NULL) {
-				in = list_next(&nt->nt_node, in);
-				continue;
-			}
-			bcopy(in->in_bssid, sr->ess[ap_num].bssid,
-			    IEEE80211_ADDR_LEN);
-			sr->ess[ap_num].ssid_len = in->in_esslen;
-			bcopy(in->in_essid, sr->ess[ap_num].ssid,
-			    in->in_esslen);
-			sr->ess[ap_num].freq = in->in_chan->ich_freq;
-
-			len = in->in_wpa_ie[1] + 2;
-			bcopy(in->in_wpa_ie, sr->ess[ap_num].wpa_ie, len);
-			sr->ess[ap_num].wpa_ie_len = len;
-
-			ap_num ++;
-			in = list_next(&nt->nt_node, in);
-		}
-		IEEE80211_NODE_UNLOCK(nt);
-		sr->count = ap_num;
-		outp->wldp_length = WIFI_BUF_OFFSET +
-		    offsetof(wl_wpa_ess_t, ess) +
-		    sr->count * sizeof (struct wpa_ess);
-		omp->b_wptr = omp->b_rptr + outp->wldp_length;
-		break;
-	case WLAN_SET_PARAM:
-		outp->wldp_result = WL_READONLY;
-		err = EINVAL;
-		break;
-	default:
-		ieee80211_err("wifi_cfg_scanresults: unknown cmmand %x\n", cmd);
-		outp->wldp_result = WL_NOTSUPPORTED;
-		err = EINVAL;
-		break;
-	}
-
-	freemsg(*mp);
-	*mp = omp;
-	return (err);
-}
-
-/*
  * Manually control the state of AUTH | DEAUTH | DEASSOC | ASSOC
  */
 static int
@@ -1308,30 +1244,6 @@
 	case WL_RSSI:
 		err = wifi_cfg_rssi(ic, cmd, mp);
 		break;
-	/*
-	 * WPA IOCTLs
-	 */
-	case WL_CAPABILITY:
-		err = wifi_cfg_caps(ic, cmd, mp);
-		break;
-	case WL_WPA:
-		err = wifi_cfg_wpa(ic, cmd, mp);
-		break;
-	case WL_KEY:
-		err = wifi_cfg_wpakey(ic, cmd, mp);
-		break;
-	case WL_DELKEY:
-		err = wifi_cfg_delkey(ic, cmd, mp);
-		break;
-	case WL_SETOPTIE:
-		err = wifi_cfg_setoptie(ic, cmd, mp);
-		break;
-	case WL_SCANRESULTS:
-		err = wifi_cfg_scanresults(ic, cmd, mp);
-		break;
-	case WL_MLME:
-		err = wifi_cfg_setmlme(ic, cmd, mp);
-		break;
 	default:
 		wifi_setupoutmsg(mp1, 0);
 		wp->wldp_result = WL_LACK_FEATURE;
@@ -1485,7 +1397,6 @@
 	bcopy(essid, ow_essid.wl_essid_essid,
 	    ow_essid.wl_essid_length);
 	bcopy(&ow_essid, wldp_buf, sizeof (wl_essid_t));
-
 }
 
 /*
@@ -1567,7 +1478,7 @@
 		ow_opmode = WL_BSS_IBSS;
 		break;
 	default:
-		ow_opmode = WL_BSS_ANY;
+		ow_opmode = WL_BSS_BSS;
 		break;
 	}
 
@@ -1949,54 +1860,6 @@
 }
 
 /*
- * MAC_PROP_WL_SCANRESULTS
- */
-
-static void
-wl_get_scanresults(struct ieee80211com *ic, void *wldp_buf)
-{
-	wl_wpa_ess_t *sr;
-	ieee80211_node_t *in;
-	ieee80211_node_table_t *nt;
-	int ap_num;
-	int len;
-
-	sr = (wl_wpa_ess_t *)wldp_buf;
-	sr->count = 0;
-	ap_num = 0;
-
-	ieee80211_dbg(IEEE80211_MSG_WPA, "wl_get_scanrelults\n");
-
-	nt = &ic->ic_scan;
-	IEEE80211_NODE_LOCK(nt);
-	in = list_head(&nt->nt_node);
-
-	while (in != NULL) {
-		/* filter out non-wpa APs */
-		if (in->in_wpa_ie == NULL) {
-			in = list_next(&nt->nt_node, in);
-			continue;
-		}
-		bcopy(in->in_bssid, sr->ess[ap_num].bssid,
-		    IEEE80211_ADDR_LEN);
-		sr->ess[ap_num].ssid_len = in->in_esslen;
-		bcopy(in->in_essid, sr->ess[ap_num].ssid,
-		    in->in_esslen);
-		sr->ess[ap_num].freq = in->in_chan->ich_freq;
-
-		len = in->in_wpa_ie[1] + 2;
-		bcopy(in->in_wpa_ie, sr->ess[ap_num].wpa_ie, len);
-		sr->ess[ap_num].wpa_ie_len = len;
-
-		ap_num++;
-		in = list_next(&nt->nt_node, in);
-	}
-	IEEE80211_NODE_UNLOCK(nt);
-	sr->count = ap_num;
-
-}
-
-/*
  * MAC_PROP_WL_ESS_LIST
  */
 static void
@@ -2096,7 +1959,7 @@
 	(void) memcpy(ie, ie_in->wpa_ie, ie_in->wpa_ie_len);
 	if (ic->ic_opt_ie != NULL) {
 		ieee80211_dbg(IEEE80211_MSG_BRUSSELS,
-		    "wl_set_optie:ic_opt_ie!=NULL\n");
+		    "wl_set_optie: ic_opt_ie != NULL\n");
 		ieee80211_free(ic->ic_opt_ie);
 	}
 	ic->ic_opt_ie = ie;
@@ -2146,8 +2009,8 @@
 	ieee80211_node_t *in;
 	wl_mlme_t *mlme = (wl_mlme_t *)wldp_buf;
 
-	ieee80211_dbg(IEEE80211_MSG_WPA, "wl_set_mlme: "
-	    "op=%d\n", mlme->im_op);
+	ieee80211_dbg(IEEE80211_MSG_WPA, "wl_set_mlme: op=%d <%s> \n",
+	    mlme->im_op, ieee80211_macaddr_sprintf(mlme->im_macaddr));
 
 	switch (mlme->im_op) {
 	case IEEE80211_MLME_DISASSOC:
@@ -2174,7 +2037,10 @@
 			err = EINVAL;
 			break;
 		}
-		if (ic->ic_des_esslen != 0) {
+		if (ic->ic_flags & IEEE80211_F_DESBSSID) {
+			in = ieee80211_find_node(&ic->ic_scan,
+			    ic->ic_des_bssid);
+		} else if (ic->ic_des_esslen != 0) {
 		/*
 		 * Desired ssid specified; must match both bssid and
 		 * ssid to distinguish ap advertising multiple ssid's.
@@ -2379,6 +2245,13 @@
  * 		When acknowledge a M_IOCTL message, this error
  * 		is ignored
  */
+
+/*
+ * Not implemented:
+ * MAC_PROP_WL_POWER_MODE
+ * MAC_PROP_WL_RADIO,
+ */
+
 /* ARGSUSED */
 int
 ieee80211_setprop(void *ic_arg, const char *pr_name, mac_prop_id_t wldp_pr_num,
@@ -2439,10 +2312,6 @@
 	case MAC_PROP_WL_SUPPORTED_RATES:
 	case MAC_PROP_WL_RSSI:
 	case MAC_PROP_WL_CAPABILITY:
-	case MAC_PROP_WL_SCANRESULTS:
-		ieee80211_err("ieee80211_setprop: opmode err\n");
-		err = EINVAL;
-		break;
 	default:
 		ieee80211_err("ieee80211_setprop: opmode not support\n");
 		err = ENOTSUP;
@@ -2506,9 +2375,6 @@
 	case MAC_PROP_WL_WPA:
 		wl_get_wpa(ic, wldp_buf);
 		break;
-	case MAC_PROP_WL_SCANRESULTS:
-		wl_get_scanresults(ic, wldp_buf);
-		break;
 	case MAC_PROP_WL_CREATE_IBSS:
 		wl_get_createibss(ic, wldp_buf);
 		break;
@@ -2547,7 +2413,6 @@
 	case MAC_PROP_WL_SUPPORTED_RATES:
 	case MAC_PROP_WL_RSSI:
 	case MAC_PROP_WL_CAPABILITY:
-	case MAC_PROP_WL_SCANRESULTS:
 	case MAC_PROP_WL_CREATE_IBSS:
 		mac_prop_info_set_perm(prh, MAC_PROP_PERM_READ);
 	}
--- old/usr/src/uts/common/net/Makefile	2012-06-12 19:55:27.236348175 +0200
+++ new/usr/src/uts/common/net/Makefile	2012-06-12 19:55:27.259741349 +0200
@@ -28,7 +28,7 @@
 
 HDRS=	af.h if.h if_arp.h if_dl.h if_types.h route.h pfkeyv2.h pfpolicy.h \
 	ppp-comp.h ppp_defs.h pppio.h vjcompress.h sppptun.h pppoe.h radix.h \
-	wpa.h simnet.h bridge.h bridge_impl.h trill.h
+	simnet.h bridge.h bridge_impl.h trill.h
 
 ROOTDIRS= $(ROOT)/usr/include/net
 
--- old/usr/src/uts/common/sys/dld.h	2012-06-12 19:55:28.000929069 +0200
+++ new/usr/src/uts/common/sys/dld.h	2012-06-12 19:55:28.023913024 +0200
@@ -119,10 +119,17 @@
 
 /*
  * Secure objects ioctls
+ * 1.WEP Static key in 64 hex-digits
+ * 2.WPA 256-bit preshared key in 64 hex-digits
+ * 3.User password string for EAP methods (except EAP-TLS) in 64 hex-digits
+ * 4.Client Private key PKCS#11 keystore PIN
  */
 typedef enum {
-	DLD_SECOBJ_CLASS_WEP = 1,
-	DLD_SECOBJ_CLASS_WPA
+	DLD_SECOBJ_CLASS_WEP = 0,
+	DLD_SECOBJ_CLASS_PSK,
+	DLD_SECOBJ_CLASS_TLS,
+	DLD_SECOBJ_CLASS_TTLS,
+	DLD_SECOBJ_CLASS_PEAP
 } dld_secobj_class_t;
 
 #define	DLD_SECOBJ_OPT_CREATE	0x00000001
--- old/usr/src/uts/common/sys/mac.h	2012-06-12 19:55:28.955046757 +0200
+++ new/usr/src/uts/common/sys/mac.h	2012-06-12 19:55:28.978320506 +0200
@@ -180,7 +180,6 @@
 	MAC_PROP_WL_PHY_CONFIG,
 	MAC_PROP_WL_CAPABILITY,
 	MAC_PROP_WL_WPA,
-	MAC_PROP_WL_SCANRESULTS,
 	MAC_PROP_WL_POWER_MODE,
 	MAC_PROP_WL_RADIO,
 	MAC_PROP_WL_ESS_LIST,
--- old/usr/src/uts/common/sys/net80211.h	2012-06-12 19:55:30.043619071 +0200
+++ new/usr/src/uts/common/sys/net80211.h	2012-06-12 19:55:30.067007526 +0200
@@ -44,7 +44,6 @@
 #include <sys/net80211_proto.h>
 #include <sys/net80211_crypto.h>
 #include <sys/net80211_ht.h>
-#include <net/wpa.h>
 
 /*
  * IEEE802.11 kernel support module
@@ -229,6 +228,9 @@
 #define	MAX_EVENT		16
 #define	MAX_IEEE80211STR	256
 
+/* required for 'arn' driver */
+#define	MAX_RSSI 		15
+
 /* For IEEE80211_RADIOTAP_FLAGS */
 #define	IEEE80211_RADIOTAP_F_CFP	0x01
 					/* sent/received during CFP */
@@ -250,6 +252,9 @@
 
 /*
  * Authentication mode.
+ * auth_algs should be only OPEN/SHARED/LEAP
+ * see IEEE80211_AUTH_ALG_* in net80211_proto.h
+ * NONE/8021X/AUTO/WPA refer to key_mgmt protocols!
  */
 enum ieee80211_authmode {
 	IEEE80211_AUTH_NONE	= 0,
@@ -257,7 +262,7 @@
 	IEEE80211_AUTH_SHARED	= 2,	/* shared-key */
 	IEEE80211_AUTH_8021X	= 3,	/* 802.1x */
 	IEEE80211_AUTH_AUTO	= 4,	/* auto-select/accept */
-	/* NB: these are used only for ioctls */
+	/* actually, this is never used */
 	IEEE80211_AUTH_WPA	= 5	/* WPA/RSN w/ 802.1x/PSK */
 };
 
@@ -268,8 +273,25 @@
 	IEEE80211_S_ASSOC	= 3,	/* try to assoc */
 	IEEE80211_S_RUN		= 4	/* associated */
 };
+
 #define	IEEE80211_S_MAX	(IEEE80211_S_RUN+1)
 
+#define	WPA_DOOR 	"/var/run/wpa_door"
+
+/*
+ * WPA State machine events
+ */
+typedef enum {
+	EVENT_ASSOC,
+	EVENT_DISASSOC,
+	EVENT_SCAN_RESULTS = 3
+} wpa_event_type;
+
+typedef struct  wl_events {
+	wpa_event_type	event;
+} wl_events_t;
+
+
 /*
  * 802.11 rate set.
  */
--- old/usr/src/uts/common/sys/net80211_proto.h	2012-06-12 19:55:31.595710113 +0200
+++ new/usr/src/uts/common/sys/net80211_proto.h	2012-06-12 19:55:31.619960110 +0200
@@ -789,7 +789,7 @@
 
 #define	WPA_OUI			0xf25000
 #define	WPA_OUI_TYPE		0x01
-#define	WPA_VERSION		1		/* current supported version */
+//#define	WPA_VERSION		1		/* current supported version */
 
 #define	IEEE80211_CHALLENGE_LEN			128
 
